/****************************************************************/
/*                                                              */
/*                       timeApp.c                              */
/*       Taiga Yonekura 2000 All Rights Reserved                */
/****************************************************************/
/* Rev:  DATE    : contents                      :name          */
/*----:----------:-------------------------------:--------------*/
/*    :2000/11/04: ԊC              :Taiga Yonkura */
/* 1.1:2001/03/03: n[h{^ǉ          :              */
/* 1.2:2001/03/17: Ȗڏڍ׉ʕύX              :              */
/*    :          : CtH[ύX            :              */
/* 1.3:2001/04/21: ꗗʃn[h{^ǉ  :              */
/* 1.4:2001/10/08: I𒆎Ԋԍcaۑǉ:              */
/*    :          :                               :              */
/****************************************************************/

#include <PalmOS.h>

#include "Comlib.h"
#include "timeRsc.h"
#include "timeTable.h"
#include "timeset.h"
#include "DbCtr.h"
#include "CalcInfo.h"
#include "DayInfo.h"

static UInt16	selectFileIdx;

//*1.4*
//Ԋ̎擾
//
static void getTimeTableName(Char *str)
{
	UInt16 tblNum;
	
	tblNum = getFileIdx();
	
	switch(tblNum){
		case 0:
			StrCopy(str,"ԊP");
			break;
		case 1:
			StrCopy(str,"ԊQ");
			break;
		case 2:
			StrCopy(str,"ԊR");
			break;
		case 3:
			StrCopy(str,"ԊS");
			break;
		
	}
}
//*1.3*
//n[hEGA{^tbN
//
static Boolean HuckHardButton(EventPtr eventP)
{
	Boolean ret = false;
	
	if ( eventP->eType == keyDownEvent) {
		switch(eventP->data.keyDown.chr){
		case vchrHard2://AhX{^
			ret = true;
			break;
		case vchrHard3:
			ret = true;//ToDo{^
			break;
		case vchrPageUp:
			ret = true;//
			break;
		case vchrPageDown:
			ret = true;//
			break;
		}
	}
	
	return ret;
}

static UInt16 StartApplication (void)
{
	initTimetable(30,30,5,4);
	initStatus();//*1.4*
	readStatusDB();//*1.4*
	readDBSchedule(getSchedulePtr());
	initCopyBuff();

	return( 0 );
}
static void StopApplication (void)
{
	writeDBSchedule(getSchedulePtr());
}
//
//CtH[̃Cxgnh
//
static Boolean MainFormHandleEvent (EventPtr event)
{
	FormPtr frm;
	Boolean handled = false;
	Char timeTableStr[50];
	
	switch(event->eType){

	case frmUpdateEvent:
		FrmDrawForm (FrmGetActiveForm());
		getTimeTableName(timeTableStr);
		FrmCopyTitle(FrmGetActiveForm(),timeTableStr);
		drawTimetable();
		handled = true;
		break;

	case frmOpenEvent:
		frm = FrmGetActiveForm();
		FrmDrawForm (frm);
		getTimeTableName(timeTableStr);
		FrmCopyTitle(FrmGetActiveForm(),timeTableStr);/*SetTitleƎ@ł̓j[o[@\ȂȂ*/
		drawTimetable();
		handled = true;
		break;
		
	case ctlSelectEvent:
	    handled = mainFrmSelectEvent(event->data.ctlEnter.controlID);
	    if(handled == true){
			initDayInfo(event->data.ctlEnter.controlID);
		}
    	break;
    	
	case penDownEvent:
		if(checkClickMainFrm(event->screenX,event->screenY) == true){
			handled = true;
		}
		break;

	case ctlRepeatEvent:
		checkTapRepeatBtn(event->data.ctlRepeat.controlID);
		break;
		
	case menuEvent:
		if(event->data.menu.itemID == 5000){
			FrmGotoForm(FileSelectForm);
			handled = true;
		} else if(event->data.menu.itemID == 5001){
			FrmGotoForm(AboutForm);
			handled = true;
		}
		break;
		
	case keyDownEvent: //*1.3*
		handled = keyDownTimeTableFrm();
		break;
		
	default:
		/*1.1*//* n[h{^ǉ (ۗ)*/
		/*handled = keyDownTimeTableFrm();*/
	}

	return handled;
}
//
//ȏڍ׏\tH[
//
static Boolean CalcInfoFormHandleEvent(EventPtr event)
{
	FormPtr frm;
	Boolean handled = false;
	
	switch(event->eType){

	case frmUpdateEvent:
		FrmDrawForm (FrmGetActiveForm());
		handled = true;
		break;

	case frmOpenEvent:
		frm = FrmGetActiveForm();
		FrmDrawForm (frm);
		initCalcInfoField();/*1.2*/
		setCalcInfoFormData();
		handled = true;
		break;
		
	case ctlSelectEvent:
    	if (event->data.ctlEnter.controlID == CalcInfoFormOkBtn){
			//start{^ꂽƂ
			getCalcInfoFormData();
			FrmGotoForm(MainForm);
			handled = true;
		} else {
			selectDayCalcInfo(event->data.ctlEnter.controlID); /*1.2*/
			handled = true;
		}
    	break;
    	
	case menuEvent:
		handled = CalcFrmMenuEvt(event->data.menu.itemID);
		break;
		
	/*1.2 s[g{^ǉ*/
	case ctlRepeatEvent:
		if(event->data.ctlRepeat.controlID == RepBtnUP){
			pushUpBtnCalcInfo();
		} else if(event->data.ctlRepeat.controlID == RepBtnDown){
			pushDownBtnCalcInfo();
		}
		break;
		
	default:
		/*1.2*//* n[h{^ǉ */
		keyDownCalcInfoFrm();
	}
	
	return handled;
}
//
//ԐݒtH[
//
static Boolean TimeInfoFormHandleEvent(EventPtr event)
{
	FormPtr frm;
	Boolean handled = false;
	
	switch(event->eType){

	case frmUpdateEvent:
		FrmDrawForm (FrmGetActiveForm());
		drawTime();
		handled = true;
		break;

	case frmOpenEvent:
		frm = FrmGetActiveForm();
		FrmDrawForm (frm);
		drawTime();
		handled = true;
		break;
		
	case ctlSelectEvent:
		handled = checkClickTimeFormBtn(event->data.ctlEnter.controlID);
    	break;

	default:
	
	}
	
	return handled;
}
//
//\tH[
//
static Boolean DayInfoFormHandleEvent(EventPtr event)
{
	Boolean handled = false;
	
	switch(event->eType){

	case frmUpdateEvent:
		drawDayInfoFrm();
		handled = true;
		break;

	case frmOpenEvent:
		drawDayInfoFrm();
		handled = true;
		break;

	case ctlRepeatEvent:
		if(event->data.ctlRepeat.controlID == RepBtnUP){
			pushUpBtnDayInfo();
		} else if(event->data.ctlRepeat.controlID == RepBtnDown){
			pushDownBtnDayInfo();
		}
		break;
		
	case ctlSelectEvent:
		if(event->data.ctlEnter.controlID == DayInfoFormOkBtn){
			FrmGotoForm (MainForm);
		} else {
			selectDayInfo(event->data.ctlEnter.controlID); /*1.1*/
		}
    	break;
    	
    case keyDownEvent: //1.3
    	keyDownDayInfoFrm();
    	handled = true;
		break;
		
	default:
		/*1.1*//* n[h{^ǉ */
		//keyDownDayInfoFrm();
		break;
	
	}
	
	return handled;
}
//
//t@CItH[
//
static Boolean FileSelectFormHandleEvent(EventPtr event)
{
	FormPtr frm;
	Boolean handled = false;
	ListPtr list;
	
	switch(event->eType){

	case frmUpdateEvent:
		frm = FrmGetActiveForm();
		list = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,CALCLIST));
		LstSetSelection(list,getFileIdx());
		FrmDrawForm (frm);
		handled = true;
		break;

	case frmOpenEvent:
		frm = FrmGetActiveForm();
		list = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,CALCLIST));
		LstSetSelection(list,getFileIdx());
		FrmDrawForm (frm);
		handled = true;
		break;
		
	case ctlSelectEvent:
		if(event->data.ctlEnter.controlID == DayInfoFormOkBtn){
			writeDBSchedule(getSchedulePtr());	//݂̐ݒۑ
			setFileIdx(selectFileIdx);
			readDBSchedule(getSchedulePtr());	//Vca̓ǂݍ
			FrmGotoForm (MainForm);
		}
    	break;
    	
	case lstSelectEvent:
		if(event->data.lstSelect.listID == CALCLIST){
			selectFileIdx = event->data.lstSelect.selection;
			handled = true;
		}
		break;
		
	default:
	
	}
	
	return handled;
}
//
//o[WtH[
//
static Boolean AboutFormHandleEvent(EventPtr event)
{
	FormPtr frm;
	Boolean handled = false;
	
	switch(event->eType){

	case frmUpdateEvent:
		FrmDrawForm (FrmGetActiveForm());
		handled = true;
		break;

	case frmOpenEvent:
		frm = FrmGetActiveForm();
		FrmDrawForm (frm);
		handled = true;
		break;
		
	case ctlSelectEvent:
		if(event->data.ctlEnter.controlID == DayInfoFormOkBtn){
			FrmGotoForm (MainForm);
		}
    	break;

	default:
	
	}
	
	return handled;
}
//
//
//
static Boolean AppHandleEvent( EventPtr eventP)
{
	UInt16 formId;
	FormPtr frmP;


	if (eventP->eType == frmLoadEvent)
		{
		// Load the form resource.
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);

		// Set the event handler for the form.  The handler of the currently
		// active form is called by FrmHandleEvent each time is receives an
		// event.
		switch(formId){

			case MainForm:
				FrmSetEventHandler(frmP, MainFormHandleEvent);
				break;

			case CalcInfoForm:
				FrmSetEventHandler(frmP, CalcInfoFormHandleEvent);
				break;

			case TimeInfoForm:
				FrmSetEventHandler(frmP, TimeInfoFormHandleEvent);
				break;

			case DayInfoForm:
				FrmSetEventHandler(frmP, DayInfoFormHandleEvent);
				break;

			case FileSelectForm:
				FrmSetEventHandler(frmP, FileSelectFormHandleEvent);
				break;

			case AboutForm:
				FrmSetEventHandler(frmP, AboutFormHandleEvent);
				break;
				
			default:
				ErrNonFatalDisplay("Invalid Form Load Event");
				break;

		}
		return true;
		}
	
	return false;
}
//
//C[`
//
static void AppEventLoop(void)
{
	UInt16 error;
	EventType event;


	do {
		EvtGetEvent(&event, evtWaitForever);
		
		if(HuckHardButton(&event)){		//*1.3*
			//*1.3*n[hEFA{^tbN
			if (! MenuHandleEvent(0, &event, &error))
				if (! AppHandleEvent(&event))
					FrmDispatchEvent(&event);
		} else {
			//*1.3*n[hEFA{^tbNȂ
			if (! SysHandleEvent(&event))
				if (! MenuHandleEvent(0, &event, &error))
					if (! AppHandleEvent(&event))
						FrmDispatchEvent(&event);
		}

	} while (event.eType != appStopEvent);
}

UInt32 PilotMain (UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	UInt16 error;

	if ( cmd == sysAppLaunchCmdNormalLaunch )
		{
		error = StartApplication ();
		if (error) return (error);

	//	FrmGotoForm (MainForm);		/*1.2 CtH[ύX*/
		firstOpenDayInfo();			/*1.2*/
		FrmGotoForm (DayInfoForm);	/*1.2*/
		
		AppEventLoop ();
		StopApplication ();
		}

	return (0);
}


